--- old/usr/src/cmd/mdb/Makefile.module	Wed Aug 21 14:46:06 2013
+++ new/usr/src/cmd/mdb/Makefile.module	Wed Aug 21 14:46:06 2013
@@ -22,6 +22,8 @@
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
+# Copyright (c) 2013 by Delphix. All rights reserved.
+#
 
 .KEEP_STATE:
 .SUFFIXES:
@@ -93,6 +95,8 @@
 kvm_TGTFLAGS		= -D_KERNEL
 proc_TGTFLAGS		= -D_USER
 
+C99MODE			= $(C99_ENABLE)
+
 CFLAGS			+= $(CCVERBOSE)
 CFLAGS64		+= $(CCVERBOSE)
 CPPFLAGS		+= $($(MDBTGT)_TGTFLAGS) -I../../../common
--- old/usr/src/cmd/mdb/common/mdb/mdb_modapi.c	Wed Aug 21 14:46:08 2013
+++ new/usr/src/cmd/mdb/common/mdb/mdb_modapi.c	Wed Aug 21 14:46:08 2013
@@ -71,6 +71,23 @@
 }
 
 ssize_t
+mdb_aread(void *buf, size_t nbytes, uintptr_t addr, void *as)
+{
+	ssize_t rbytes = mdb_tgt_aread(mdb.m_target, as, buf, nbytes, addr);
+
+	if (rbytes > 0 && rbytes < nbytes)
+		return (set_errbytes(rbytes, nbytes));
+
+	return (rbytes);
+}
+
+ssize_t
+mdb_awrite(const void *buf, size_t nbytes, uintptr_t addr, void *as)
+{
+	return (mdb_tgt_awrite(mdb.m_target, as, buf, nbytes, addr));
+}
+
+ssize_t
 mdb_fread(void *buf, size_t nbytes, uintptr_t addr)
 {
 	ssize_t rbytes = mdb_tgt_fread(mdb.m_target, buf, nbytes, addr);
--- old/usr/src/cmd/mdb/common/mdb/mdb_modapi.h	Wed Aug 21 14:46:09 2013
+++ new/usr/src/cmd/mdb/common/mdb/mdb_modapi.h	Wed Aug 21 14:46:09 2013
@@ -21,7 +21,7 @@
 
 /*
  * Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2012 by Delphix. All rights reserved.
+ * Copyright (c) 2013 by Delphix. All rights reserved.
  * Copyright (c) 2012 Joyent, Inc. All rights reserved.
  */
 
@@ -207,6 +207,9 @@
 extern ssize_t mdb_vread(void *, size_t, uintptr_t);
 extern ssize_t mdb_vwrite(const void *, size_t, uintptr_t);
 
+extern ssize_t mdb_aread(void *, size_t, uintptr_t, void *);
+extern ssize_t mdb_awrite(const void *, size_t, uintptr_t, void *);
+
 extern ssize_t mdb_fread(void *, size_t, uintptr_t);
 extern ssize_t mdb_fwrite(const void *, size_t, uintptr_t);
 
--- old/usr/src/cmd/mdb/common/modules/conf/mapfile-extern	Wed Aug 21 14:46:10 2013
+++ new/usr/src/cmd/mdb/common/modules/conf/mapfile-extern	Wed Aug 21 14:46:10 2013
@@ -1,6 +1,6 @@
 #
 # Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
-# Copyright (c) 2012 by Delphix. All rights reserved.
+# Copyright (c) 2013 by Delphix. All rights reserved.
 #
 # CDDL HEADER START
 #
@@ -45,13 +45,16 @@
 #		Pmapping_iter			{ FLAGS = EXTERN };
 
 		_mdb_ks_ncpu			{ FLAGS = EXTERN };
+		_mdb_ks_pagemask		{ FLAGS = EXTERN };
+		_mdb_ks_pageoffset		{ FLAGS = EXTERN };
 		_mdb_ks_pageshift		{ FLAGS = EXTERN };
 		_mdb_ks_pagesize		{ FLAGS = EXTERN };
-		_mdb_ks_pageoffset		{ FLAGS = EXTERN };
 
 		mdb				{ FLAGS = EXTERN };
 		mdb_add_walker			{ FLAGS = EXTERN };
 		mdb_alloc			{ FLAGS = EXTERN };
+		mdb_aread			{ FLAGS = EXTERN };
+		mdb_awrite			{ FLAGS = EXTERN };
 		mdb_call_dcmd			{ FLAGS = EXTERN };
 		mdb_callback_add		{ FLAGS = EXTERN };
 		mdb_callback_remove		{ FLAGS = EXTERN };
--- old/usr/src/cmd/mdb/common/modules/genunix/Makefile.files	Wed Aug 21 14:46:11 2013
+++ new/usr/src/cmd/mdb/common/modules/genunix/Makefile.files	Wed Aug 21 14:46:11 2013
@@ -22,6 +22,7 @@
 # Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
 # Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright (c) 2013, Joyent, Inc.  All rights reserved.
+# Copyright (c) 2013 by Delphix. All rights reserved.
 #
 
 #
@@ -46,6 +47,7 @@
 	findstack.c	\
 	findstack_subr.c \
 	fm.c		\
+	gcore.c		\
 	genunix.c	\
 	group.c		\
 	hotplug.c	\
--- old/usr/src/cmd/mdb/common/modules/genunix/avl.c	Wed Aug 21 14:46:13 2013
+++ new/usr/src/cmd/mdb/common/modules/genunix/avl.c	Wed Aug 21 14:46:13 2013
@@ -22,9 +22,10 @@
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright (c) 2013 by Delphix. All rights reserved.
+ */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/avl.h>
 
 #include <mdb/mdb_modapi.h>
@@ -282,4 +283,26 @@
 		mdb_free(aw->aw_buff, aw->aw_tree.avl_size);
 
 	mdb_free(aw, sizeof (struct aw_info));
+}
+
+/*
+ * This function is named avl_walk_mdb to avoid a naming conflict with the
+ * existing avl_walk function.
+ */
+int
+avl_walk_mdb(uintptr_t addr, mdb_walk_cb_t callback, void *cbdata)
+{
+	mdb_walk_state_t ws;
+	int ret;
+
+	ws.walk_addr = addr;
+	ws.walk_callback = callback;
+	ws.walk_cbdata = cbdata;
+
+	avl_walk_init(&ws);
+	while ((ret = avl_walk_step(&ws)) == WALK_NEXT)
+		continue;
+	avl_walk_fini(&ws);
+
+	return (ret);
 }
--- old/usr/src/cmd/mdb/common/modules/genunix/avl.h	Wed Aug 21 14:46:14 2013
+++ new/usr/src/cmd/mdb/common/modules/genunix/avl.h	Wed Aug 21 14:46:14 2013
@@ -22,12 +22,13 @@
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright (c) 2013 by Delphix. All rights reserved.
+ */
 
 #ifndef	_MDB_AVL_H
 #define	_MDB_AVL_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifdef	__cplusplus
 extern "C" {
 #endif
@@ -47,6 +48,7 @@
     int (*)(void *, uintptr_t, void *), void *);
 extern int avl_walk_step(mdb_walk_state_t *);
 extern void avl_walk_fini(mdb_walk_state_t *wsp);
+extern int avl_walk_mdb(uintptr_t, mdb_walk_cb_t, void *);
 
 #ifdef	__cplusplus
 }
